package Math;

import java.util.ArrayList;
import java.util.Random;

import Objekts.Ball;

public class BallGenerator {
	int Screen_W = 0, Screen_H = 0; 

	public BallGenerator(int Screen_W, int Screen_H) {
		this.Screen_W = Screen_W; 
		this.Screen_H = Screen_H; 	
	}
	
	public ArrayList BallList(int n) {
		ArrayList<Ball> BallSet = new ArrayList<>(); 
		Random rand = new Random(); 
		Ball currentBall; 
		
		while(BallSet.size() < n){
			int radius = 5; //rand.nextInt( 10 ) + 1; 
			int xPos = rand.nextInt(Screen_W + 2 * radius) + radius; 
			int yPos = rand.nextInt(Screen_W + 2 * radius) + radius; 			
			int xVel = rand.nextInt( 5 ) + 1; 
			int yVel = rand.nextInt( 5 ) + 1;
			int speed = rand.nextInt( 5 );
			int mass = radius; 
			// check if there is an similar Ball at the same position in the list
			boolean contains = false; 
			for(int i = 0; i < BallSet.size(); i++){
				Ball tmpBall = BallSet.get(i); 
				if(tmpBall.position().x() == xPos && tmpBall.position().y() == yPos)
					contains = true;
			}
			if(contains == true) continue; 
			
			currentBall = new Ball(new Vektor2D(xPos, yPos), new Vektor2D(xVel, yVel), speed, mass, radius); 
			
			boolean collides = false; 
			for(int i = 0; i < BallSet.size(); i++){
				if(currentBall.collides(BallSet.get(i)))
					collides = true; 
			}			
			if(collides == true) continue; 
			else BallSet.add(currentBall); 

		}
		
		return BallSet;
	}

}
